#框架配置文件说明  
框架目录Toknot/Config/default.ini是默认配置项目，请不要修改。在通过命令行工具初始化应用时，该文件会被复制为/your-app-path/config/config.ini,请修改此文件。  
在配置选项中，涉及到使用相对文件路径时，如果没有说明，都是相对于创建的应用根目录   
下面是配置说明：

```ini
;日志相关配置
[Log]
;是否激活日志保存到文件
enableLog = false 
;日志文件保存位置，如果填写的是相对位置，位置将相对于项目应用根目录
logSavePath  = var/log

[Database]
;Database connect DSN
;MySQL  see http://www.php.net/manual/en/ref.pdo-mysql.connection.php
;SQLite  see http://www.php.net/manual/en/ref.pdo-sqlite.connection.php
;Firebird/Interbase see http://www.php.net/manual/en/ref.pdo-firebird.connection.php
;PostgreSQL see http://www.php.net/manual/en/ref.pdo-pgsql.connection.php
dsn = 

;username of database connect 
username = 

;password of database connect
password  = 

;数据库连接选项，为数组格式，key值使用PDO为类常量
;the index support use of PDO constant
;dirverOptions[PDO::MYSQL_ATTR_INIT_COMMAND] = SET NAMES UTF8
dirverOptions[] =

;表名前缀，在通过数据库对象属性访问表对象时，属性名在配置后步包括前缀
tablePrefix = 

;数据库表清单缓存文件，相对路径为相对于项目根目录
;如果没有设置将不会缓存
databaseStructInfoCache = var/database/databaseTaleListCache

;表清单缓存时间，单位为分钟
databaseStructInfoCacheExpire = 3600 

;数据库单表清单缓存文件前缀，
databaseTableStructCache = var/database/tableStructCache

;数据库单表清单缓存有效期，单位为分钟
databaseTableStructCacheExpire = 3600


[View]
;path of the template file of view layer store directory, relative to your application root directory or set one absolute path
templateFileScanPath = View

;path of the template file be parse to php file store directory,relative to your application root directory or set one absolute path
templateCompileFileSavePath = var/view/compile

;name of template file extension
templateFileExtensionName = html

;relative to your application root directory or set one absolute path
htmlStaticCachePath = var/view/HTML

;relative to your application root directory or set one absolute path
dataCachePath = var/view/Data
defaultPrintCacheThreshold = 2

[User]
allowRootLogin = false

;Use Toknot\User\Root::getEncryptionRootPass() method encrypt one password string
rootPassword =

;User password encriyption algorithms when enable hash function of PHP
userPasswordEncriyptionAlgorithms = sha512

;set salt for hash password
userPasswordEncriyptionSalt = salt

;user table name without preifx in database
userTableName = user

;ID column name of user
userIdColumnName = uid
userNameColumnName = username
userGroupIdColumnName = gid
userPasswordColumnName = password

[Session]
sessionName = _TKSID

;whether use file store data of session, otherwise set false 
fileStoreSession = true

;relative to your application root directory or set one absolute path
fileStorePath = var/session

maxLifeTime = 3600

[Admin]
;session name
adminSessionName = _TKASID

;name of section of database configure, if multiDatabase is true, the value is preifx of
;section, multi-database section name use the prefix plus suffix number and number start 0

databaseOptionSectionName = Database

;if the key set false, admin app will use Database of navigation config
;but if adminNavigationListTable is null will still used ini file
adminUseIniNavigationConfig = true

;admin nav menu list table name
;note: if the Database section has set tablePrefix, there do not contain the prefix
adminNavigationListTable = tk_navigation_menu

;admin nav menu list config file
adminNavigationListIniFile = navigation.ini

;以下为应用相关设置项
[App]
;应用顶级命名空间
rootNamespace = null

;时区设置，支持下列格式
;+0800 与 +8 相同
;Etc/GMT-8
;php 时区名字
timeZone = UTC

;当控制器为找到时调用的控制器，类似于web服务器的404文件
;该控制器的必须位于应用Controller命名空间下，这里的配置项请去掉Controller以上的名字空间
;Note:in the controller DO NOT set "404 Not Found" head
;notFoundController = "\NotFound"
notFoundController = null 

;当http请求方法步允许时调用的控制器
;该控制器的必须位于应用Controller命名空间下，这里的配置项请去掉Controller以上的名字空间
;note:in the controller DO NOT set "405 Method Not Allowed" head
;methodNotAllowedController = "\MethodNotAllowed"
methodNotAllowedController = null

;默认控制器，在请求时没有明确指定子控制器时，该控制器将会被调用，类似web服务器的index文件
;这里只需配置 命名空间分隔符 加 类名
;this is only class name, the namespace be determined by present access URI
defaultInvokeController = \Index

;禁止访问控制器
forbiddenController = null

noPermissionController = null

;路由模式配置：
;   ROUTER_PATH             将请求URI中的路径映射到应用的控制器,
;                           将会从路径开始向右找，直到找到类文件为止，如果没有找到将返回NotFound
;                           如果提前找到，路径中剩余的部分为PATH传参
;   ROUTER_GET_QUERY        将HTTP请求中GET参数中的第一个参数的KEY值作为映射路径
;                           寻找模式是精确匹配，且路径必须为第一个参数KEY,KEY必须以 / 开头
;   ROUTER_MAP_TABLE        按照路由表配置进行映射，路由表配置文件为 config/router_map.ini
;                           此模式将按配置中的action进行精确匹配
routerMode = ROUTER_PATH

;在直接路径映射模式中，可以通过设置本项控制匹配深度，小于或等于0将没有限制
routerDepth = 0

;调用应用控制器前调用的控制器，同样会调用指定http method 对应的类方法，仅当该方法返回bool类型 false 时，
;路由器将不会引导映射控制器，
beforeInvokeController = null

;在映射控制器运行结束后，下面配置的控制器将会被调用，beforeInvokeController返回状态不会影响afterInvokeController的调用
afterInvokeController = null
```

以下为路由表说名,路由表配置文件需要自行在应用的config目录下创建，文件名为`router_map.ini`  
一个配置块为一个规则，块名是符合PHP变量命名规范的任意字符，但是不要重复，否则前面的会被覆盖，每个配置快下包含两个配置项，分别是:pattern 匹配规则;action 映射控制器

```ini
;第一个路由规则
[map0]
;匹配规则，一个正则表达式，最好用双引号包括
pattern = "/User/(.*)/Profile"
;映射控制器的类名，类名不包括Controller名字以前的部分
action = \User\Info

[map1]
pattern = "/User/(.*)/Avatar"
action = \User\Info

[map2]
pattern = "/User/(.*)/Password"
action = \User\Safe
```